VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CPolygon"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'***************************************************************
'  ,     :
'                (mko )     (mko - More known As)
'           >> email: sls_hacker@mail.ru
'           >> ICQ:   329-880-831
'           >> Site:  www.vbstreets.ru
'                     bbs.vbstreets.ru
'
' Fire-Lines (c) 2007
'
'      Visual Basic - www.vbstreets.ru
'        , 
'     .     :)
' ******************************************************************

Private local_Position          As T_VECTOR_2   '  
Private local_Scaling           As T_VECTOR_2   '  
Private local_RotAngle          As Double       '    

Private local_BoundingBoxMax    As T_VECTOR_2   '   
Private local_BoundingBoxMin    As T_VECTOR_2   '   
Private local_Vertecies()       As T_VECTOR_2   '  
Private local_VertCounter       As Long         '  

Private local_Transformation    As T_MATRIX_2X2 '   
Private local_Marker            As Long         '  


Private Const BBOX_COLOR = vbBlue
Private Const BBOX_MARKER_BORDER = vbBlack
Private Const BBOX_MARKER_BG_SZ = vbGreen
Private Const BBOX_MARKER_BG_CT = vbRed


Public Sub AddVertex(ByVal x As Double, ByVal y As Double)
    local_VertCounter = local_VertCounter + 1
    ReDim Preserve local_Vertecies(1 To local_VertCounter)
    With local_Vertecies(local_VertCounter)
        .x = x
        .y = y
    End With
    
    If x > local_BoundingBoxMax.x Then
        local_BoundingBoxMax.x = x
    End If
    
    If x < local_BoundingBoxMin.x Then
        local_BoundingBoxMin.x = x
    End If
    
    If y > local_BoundingBoxMax.y Then
        local_BoundingBoxMax.y = y
    End If
    
    If y < local_BoundingBoxMin.y Then
        local_BoundingBoxMin.y = y
    End If
    
End Sub


Public Sub Render()
    Dim CurrentVertex As T_VECTOR_2
    Dim i As Long
    CurrentVertex = SumVectors(local_Position, VxM(SuperScaleVectors(local_Vertecies(1), local_Scaling), local_Transformation))
    
    RenderSurface.CurrentX = CurrentVertex.x
    RenderSurface.CurrentY = CurrentVertex.y
    
    For i = local_VertCounter To 1 Step -1
        CurrentVertex = SumVectors(local_Position, VxM(SuperScaleVectors(local_Vertecies(i), local_Scaling), local_Transformation))
        RenderSurface.Line -(CurrentVertex.x, CurrentVertex.y)
    Next i
    
End Sub

Private Sub Class_Initialize()
    local_Transformation = CreateMatrixRotation(0)
    local_Scaling.x = 1
    local_Scaling.y = 1
End Sub

Public Sub Rotate(ByVal dDeltaAngle As Double)
    Me.Rotation = local_RotAngle + dDeltaAngle
End Sub

Public Property Get Rotation() As Double
    Rotation = local_RotAngle
    
End Property

Public Property Let Rotation(ByVal dAngle As Double)
    local_RotAngle = dAngle
    local_Transformation = CreateMatrixRotation(dAngle)
End Property

Public Sub DrawBoundingRect()
    Dim BR1     As T_VECTOR_2
    Dim BR2     As T_VECTOR_2
    Dim BR3     As T_VECTOR_2
    Dim BR4     As T_VECTOR_2
    Dim BScale  As T_VECTOR_2
    
    BR1 = local_BoundingBoxMax
    BR2 = local_BoundingBoxMax
    BR3 = local_BoundingBoxMin
    BR4 = local_BoundingBoxMin
    
    BR2.y = local_BoundingBoxMin.y
    BR4.y = local_BoundingBoxMax.y
    
    BScale = ScaleVector(local_Scaling, 1.1)
    
    
    BR1 = SuperScaleVectors(BR1, BScale)
    BR2 = SuperScaleVectors(BR2, BScale)
    BR3 = SuperScaleVectors(BR3, BScale)
    BR4 = SuperScaleVectors(BR4, BScale)
    
    '    VB -     With- :(
    BR1 = VxM(BR1, local_Transformation)
    BR2 = VxM(BR2, local_Transformation)
    BR3 = VxM(BR3, local_Transformation)
    BR4 = VxM(BR4, local_Transformation)
    
    BR1 = SumVectors(BR1, local_Position)
    BR2 = SumVectors(BR2, local_Position)
    BR3 = SumVectors(BR3, local_Position)
    BR4 = SumVectors(BR4, local_Position)
    
    RenderSurface.Line (BR1.x, BR1.y)-(BR2.x, BR2.y), BBOX_COLOR
    RenderSurface.Line (BR3.x, BR3.y)-(BR2.x, BR2.y), BBOX_COLOR
    RenderSurface.Line (BR3.x, BR3.y)-(BR4.x, BR4.y), BBOX_COLOR
    RenderSurface.Line (BR1.x, BR1.y)-(BR4.x, BR4.y), BBOX_COLOR
    
End Sub

Private Function WorldToLocal(WorldCoordinates As T_VECTOR_2) As T_VECTOR_2
    WorldCoordinates = SumVectors(WorldCoordinates, ScaleVector(local_Position, -1))
    WorldCoordinates = VxM(WorldCoordinates, CreateMatrixRotation(-local_RotAngle))
    WorldToLocal = SuperScaleVectors(WorldCoordinates, InverseVector(local_Scaling))
End Function

Public Function TestPointInPolygon(ByVal x As Double, ByVal y As Double) As Boolean
    Dim Point As T_VECTOR_2
    Point = CreateVector(x, y)
    '          WorldToLocal() :)
    
    Point = WorldToLocal(Point)
    
    '          
    ' .. ,     -    
    
    '   06:13.      -  
    
    '    -,     .
    '      ,    :
    
    With Point
        If .x < local_BoundingBoxMax.x And _
           .y < local_BoundingBoxMax.y And _
           .x > local_BoundingBoxMin.x And _
           .y > local_BoundingBoxMin.y Then
           
            '    .  ,     
            '     ,    ,  , 
            '     .  ,   
            ' - .
            '     ,    .   :)
            '       .       -
            '  .
            '  -      .
            '    .   RayShading
            '     RayShade. .
            ' (   06:22 -       :) )
            
            '  ,    ( , ,    ?)
            ' ,    .   ,   
            '         (,   )
            '   :
            '       ,     
            '                     +     +      +
            '         () - 
            '       
            '  .      , 
            '      8).   -     :)
            
            
            ' , ,  d3drm,      , 
            '     GameDev.ru . .      .
            '     .   ,   -   8)
            
            ' 06:40 -    :)
            
            ''' [04--2007 12:39:44]
            '''     
            '''
            '''
            ''' [04--2007 12:40:16]
            '''Public Function GetLinesIntersection(From1 As VECTOR, To1 As VECTOR, From2 As VECTOR, To2 As VECTOR) As VECTOR
            '''Dim ACoef1 As Single
            '''Dim ACoef2 As Single
            '''Dim BCoef1 As Single
            '''Dim BCoef2 As Single
            '''Dim Delta As Single
            '''Dim DeltaX As Single
            '''Dim DeltaY As Single
            '''
            '''ACoef1 = (To1.y - From1.y) / (To1.x - From1.x)
            '''ACoef2 = (To2.y - From2.y) / (To2.x - From2.x)
            '''
            '''BCoef1 = From1.y - From1.x * ACoef1
            '''BCoef2 = From2.y - From2.x * ACoef2
            '''
            '''Delta = ACoef2 - ACoef1
            '''DeltaX = BCoef1 - BCoef2
            '''DeltaY = ACoef1 * BCoef2 - BCoef1 * ACoef2
            '''
            '''GetLinesIntersection.x = DeltaX / Delta
            '''GetLinesIntersection.y = -DeltaY / Delta
            '''End Function
            '''
            '''
            '''OrBit                 [04--2007 12:40:19]
            '''     
            '''
            '''
            '''OrBit                 [04--2007 12:40:29]
            '''     
            '''
            '''
            '''OrBit                 [04--2007 12:40:45]
            ''',     ;)
            '''
            '''
            ''' [04--2007 12:40:57]
            ''' 
            '''
            '''
            ''' [04--2007 12:41:03]
            '''   
            '''
            '''
            ''' [04--2007 12:41:14]
            '''     
            '''           
            '''
            '''OrBit                 [04--2007 12:41:26]
            ''' ,   )
            '''
            
            '   ,  -     ,   -

                                  
            ' 08:57 - ...
            
            
            Dim TraceStart          As T_VECTOR_2
            Dim Intersections       As Long
            TraceStart = SumVectors(local_BoundingBoxMax, CreateVector(10000, 10000))
            
            For i = 1 To local_VertCounter
                If TestLinesIntersected(TraceStart, Point, local_Vertecies(i), local_Vertecies((i Mod local_VertCounter) + 1)) Then
                    Intersections = Intersections + 1
                End If
            Next i
            TestPointInPolygon = ((Intersections Mod 2) = 1) And (Intersections > 0)
            
            
            
        End If
    End With
End Function

Public Sub DrawSizingMarkers()
    Dim BR1     As T_VECTOR_2
    Dim BR2     As T_VECTOR_2
    Dim BR3     As T_VECTOR_2
    Dim BR4     As T_VECTOR_2
    Dim Rotor   As T_VECTOR_2
    Dim BScale  As T_VECTOR_2
    
    BR1 = local_BoundingBoxMax
    BR2 = local_BoundingBoxMax
    BR3 = local_BoundingBoxMin
    BR4 = local_BoundingBoxMin
    
    BR2.y = local_BoundingBoxMin.y
    BR4.y = local_BoundingBoxMax.y
    
    
    
    BScale = ScaleVector(local_Scaling, 1.1)
    
    
    BR1 = SuperScaleVectors(BR1, BScale)
    BR2 = SuperScaleVectors(BR2, BScale)
    BR3 = SuperScaleVectors(BR3, BScale)
    BR4 = SuperScaleVectors(BR4, BScale)
    Rotor.y = BR1.y + 35
    
    '    VB -     With- :(
    BR1 = VxM(BR1, local_Transformation)
    BR2 = VxM(BR2, local_Transformation)
    BR3 = VxM(BR3, local_Transformation)
    BR4 = VxM(BR4, local_Transformation)
    Rotor = VxM(Rotor, local_Transformation)
    
    BR1 = SumVectors(BR1, local_Position)
    BR2 = SumVectors(BR2, local_Position)
    BR3 = SumVectors(BR3, local_Position)
    BR4 = SumVectors(BR4, local_Position)
    Rotor = SumVectors(Rotor, local_Position)
    
    RenderSurface.FillStyle = vbFSSolid
    RenderSurface.FillColor = BBOX_MARKER_BG_SZ
    '   
    RenderSurface.Circle (BR1.x, BR1.y), 8, BBOX_MARKER_BORDER
    RenderSurface.Circle (BR2.x, BR2.y), 8, BBOX_MARKER_BORDER
    RenderSurface.Circle (BR3.x, BR3.y), 8, BBOX_MARKER_BORDER
    RenderSurface.Circle (BR4.x, BR4.y), 8, BBOX_MARKER_BORDER
    
    
    RenderSurface.Line ((BR1.x + BR4.x) / 2, (BR1.y + BR4.y) / 2)-(Rotor.x, Rotor.y), vbBlack
    
    '   
    RenderSurface.Circle ((BR1.x + BR2.x) / 2, (BR1.y + BR2.y) / 2), 8, BBOX_MARKER_BORDER
    RenderSurface.Circle ((BR3.x + BR2.x) / 2, (BR3.y + BR2.y) / 2), 8, BBOX_MARKER_BORDER
    RenderSurface.Circle ((BR3.x + BR4.x) / 2, (BR3.y + BR4.y) / 2), 8, BBOX_MARKER_BORDER
    RenderSurface.Circle ((BR1.x + BR4.x) / 2, (BR1.y + BR4.y) / 2), 8, BBOX_MARKER_BORDER
    
    RenderSurface.FillColor = vbYellow
    RenderSurface.Circle (Rotor.x, Rotor.y), 8, BBOX_MARKER_BORDER
    
End Sub

Public Function TryMarkerCapture(ByVal x As Double, ByVal y As Double) As Long
    On Error Resume Next
    Dim ClickedPoint As T_VECTOR_2
    ClickedPoint = CreateVector(x, y)
    ClickedPoint = WorldToLocal(ClickedPoint)
    Select Case 14
        Case Is >= GetDistance(ClickedPoint, ScaleVector(local_BoundingBoxMax, 1.1))
            local_Marker = MARKER_RT
        Case Is >= GetDistance(ClickedPoint, ScaleVector(local_BoundingBoxMin, 1.1))
            local_Marker = MARKER_LB
        Case Is >= GetDistance(ClickedPoint, ScaleVector(CreateVector(local_BoundingBoxMax.x, local_BoundingBoxMin.y), 1.1))
            local_Marker = MARKER_RB
        Case Is >= GetDistance(ClickedPoint, ScaleVector(CreateVector(local_BoundingBoxMin.x, local_BoundingBoxMax.y), 1.1))
            local_Marker = MARKER_LT
            
        Case Is >= GetDistance(ClickedPoint, ScaleVector(CreateVector(local_BoundingBoxMax.x, (local_BoundingBoxMax.y + local_BoundingBoxMin.y) / 2), 1.1))
            local_Marker = MARKER_RC
        Case Is >= GetDistance(ClickedPoint, ScaleVector(CreateVector(local_BoundingBoxMin.x, (local_BoundingBoxMax.y + local_BoundingBoxMin.y) / 2), 1.1))
            local_Marker = MARKER_LC
        Case Is >= GetDistance(ClickedPoint, ScaleVector(CreateVector((local_BoundingBoxMax.x + local_BoundingBoxMin.x) / 2, local_BoundingBoxMax.y), 1.1))
            local_Marker = MARKER_TC
        Case Is >= GetDistance(ClickedPoint, ScaleVector(CreateVector((local_BoundingBoxMax.x + local_BoundingBoxMin.x) / 2, local_BoundingBoxMin.y), 1.1))
            local_Marker = MARKER_BC
        Case Is >= GetDistance(ClickedPoint, SumVectors(CreateVector(0, 35 / local_Scaling.y), ScaleVector(CreateVector((local_BoundingBoxMax.x + local_BoundingBoxMin.x) / 2, local_BoundingBoxMax.y), 1.1)))
            local_Marker = MARKER_ROTOR
        Case Else
            local_Marker = 0
    End Select
    Debug.Print GetDistance(ClickedPoint, SumVectors(CreateVector(0, 0), ScaleVector(CreateVector((local_BoundingBoxMax.x + local_BoundingBoxMin.x) / 2, local_BoundingBoxMax.y), 1.1)))
    TryMarkerCapture = local_Marker
End Function

Public Sub ReleaseMarker()
    local_Marker = 0
End Sub

Public Sub ApplyMarkerPosititon(ByVal x As Double, ByVal y As Double)
     Dim NewPos As T_VECTOR_2
     Dim Scaler As T_VECTOR_2
     
     NewPos = CreateVector(x, y) '    CopyMemory   .   
     NewPos = WorldToLocal(NewPos)
     NewPos = ScaleVector(NewPos, 1 / 1.1)
     NewPos = SuperScaleVectors(NewPos, local_Scaling)
     
     Select Case local_Marker
        Case MARKER_RT
            local_Scaling = SuperScaleVectors(NewPos, InverseVector(local_BoundingBoxMax))
        Case MARKER_LB
            local_Scaling = SuperScaleVectors(NewPos, InverseVector(local_BoundingBoxMin))
       
        Case MARKER_RB
            local_Scaling = SuperScaleVectors(NewPos, InverseVector(CreateVector(local_BoundingBoxMax.x, local_BoundingBoxMin.y)))
        Case MARKER_LT
            local_Scaling = SuperScaleVectors(NewPos, InverseVector(CreateVector(local_BoundingBoxMin.x, local_BoundingBoxMax.y)))
            
        Case MARKER_RC
            local_Scaling.x = NewPos.x / local_BoundingBoxMax.x
        Case MARKER_LC
            local_Scaling.x = NewPos.x / local_BoundingBoxMin.x
        Case MARKER_TC
            local_Scaling.y = NewPos.y / local_BoundingBoxMax.y
        Case MARKER_BC
            local_Scaling.y = NewPos.y / local_BoundingBoxMin.y
        Case MARKER_ROTOR
            Me.Rotate VectorAngle(NewPos)
     End Select
     
     
     
End Sub

Public Sub Move(ByVal x As Double, ByVal y As Double)
    local_Position.x = local_Position.x + x
    local_Position.y = local_Position.y + y
End Sub

Public Sub SetScale(ByVal x As Double, ByVal y As Double)
    local_Scaling.x = x
    local_Scaling.y = y
End Sub

