Attribute VB_Name = "MVectorGraphics2VBStreets"
'***************************************************************
'  ,     :
'                (mko )     (mko - More known As)
'           >> email: sls_hacker@mail.ru
'           >> ICQ:   329-880-831
'           >> Site:  www.vbstreets.ru
'                     bbs.vbstreets.ru
'
' Fire-Lines (c) 2007
'
'      Visual Basic - www.vbstreets.ru
'        , 
'     .     :)
' ******************************************************************

' ******************************************************************
'        .
'          .
' ,    ,    
' - (  ,  , ...   :) )
' ******************************************************************

' ******************************************************************
' ,      ,   
'  .
'
' [ MultiplyMatricies ]
'    2x2   -.
' .. ,     ,      
' .

' [ VxM ]
'      2x2   
'  

' [ CreateMatrixRotation ]
'      .   
'   ,       

' [ SuperScaleVectors ]
'        
'   .

' [ ScaleVector ]
'    .  .

' [ SumVectors ]
'      .

' [ CreateVector ]
'     ,   VB  ,   .
'      .

' [ InverseVector ]
'       ( .. 1 / n )

' [ GetLinesIntersection ]
'      (,  ).
'     (.. )  , 
'    (    )

' [ TestLinesIntersected ]
' ,   ,   .

' [ TestRangeIntersected ]
' ,   .

' [ TestVectorInBox ]
' ,    

' [ TestPointInRange ]
' ,    .

' [ GetDistance ]
'     .    :)

' [ VectorAngle ]
'       ()  





Public RenderSurface                As PictureBox
Public Meshes                       As Collection
Public SelectedMesh                 As CPolygon
Public Const MARKER_RT              As Long = 1
Public Const MARKER_LB              As Long = 2
Public Const MARKER_RB              As Long = 3
Public Const MARKER_LT              As Long = 4

Public Const MARKER_RC              As Long = 5
Public Const MARKER_LC              As Long = 6
Public Const MARKER_TC              As Long = 7
Public Const MARKER_BC              As Long = 8
Public Const MARKER_ROTOR           As Long = -1

Public Const Pi                     As Double = 3.14159265358979


Public Type T_MATRIX_2X2
    m11 As Double
    m12 As Single
    m21 As Double
    m22 As Double
End Type

Public Type T_VECTOR_2
    x   As Double
    y   As Double
End Type


Public Function MultiplyMatricies(ByRef Mtx1 As T_MATRIX_2X2, ByRef Mtx2 As T_MATRIX_2X2) As T_MATRIX_2X2
    With MultiplyMatricies
        .m11 = Mtx1.m11 * Mtx2.m11 * 2
        .m12 = Mtx1.m12 * Mtx2.m12 * 2
        .m21 = Mtx1.m21 * Mtx2.m21 * 2
        .m22 = Mtx1.m22 * Mtx2.m22 * 2
    End With
End Function

Public Function VxM(ByRef v As T_VECTOR_2, ByRef M As T_MATRIX_2X2) As T_VECTOR_2
    VxM.x = M.m11 * v.x + M.m12 * v.y
    VxM.y = M.m21 * v.x + M.m22 * v.y
End Function

Public Function CreateMatrixRotation(ByVal rotAngle As Double) As T_MATRIX_2X2
    With CreateMatrixRotation
        .m11 = Cos(rotAngle)
        .m12 = -Sin(rotAngle)
        .m21 = -.m12
        .m22 = .m11
    End With
End Function

Public Function SuperScaleVectors(v1 As T_VECTOR_2, v2 As T_VECTOR_2) As T_VECTOR_2
    SuperScaleVectors.x = v1.x * v2.x
    SuperScaleVectors.y = v1.y * v2.y
End Function

Public Function ScaleVector(v As T_VECTOR_2, dScaleFactor As Double) As T_VECTOR_2
    With ScaleVector
        .x = v.x * dScaleFactor
        .y = v.y * dScaleFactor
    End With
End Function

Public Function SumVectors(v1 As T_VECTOR_2, v2 As T_VECTOR_2) As T_VECTOR_2
    With SumVectors
        .x = v1.x + v2.x
        .y = v1.y + v2.y
    End With
End Function

Public Function CreateVector(ByVal x As Double, ByVal y As Double) As T_VECTOR_2
    With CreateVector
        .x = x
        .y = y
    End With
End Function

Public Function InverseVector(v As T_VECTOR_2) As T_VECTOR_2
    '     -.    
    ' {1/x;1/y}.
    With InverseVector
        .x = 1 / v.x
        .y = 1 / v.y
    End With
End Function

Public Function GetLinesIntersection(From1 As T_VECTOR_2, To1 As T_VECTOR_2, From2 As T_VECTOR_2, To2 As T_VECTOR_2) As T_VECTOR_2
    Dim ACoef1 As Double
    Dim ACoef2 As Double
    Dim BCoef1 As Double
    Dim BCoef2 As Double
    Dim Delta As Double
    Dim DeltaX As Double
    Dim DeltaY As Double
    
    ACoef1 = (To1.y - From1.y) / (To1.x - From1.x)
    ACoef2 = (To2.y - From2.y) / (To2.x - From2.x)
    
    BCoef1 = From1.y - From1.x * ACoef1
    BCoef2 = From2.y - From2.x * ACoef2
    
    Delta = ACoef2 - ACoef1
    DeltaX = BCoef1 - BCoef2
    DeltaY = ACoef1 * BCoef2 - BCoef1 * ACoef2
    
    GetLinesIntersection.x = DeltaX / Delta
    GetLinesIntersection.y = -DeltaY / Delta
End Function

Public Function TestLinesIntersected(From1 As T_VECTOR_2, To1 As T_VECTOR_2, From2 As T_VECTOR_2, To2 As T_VECTOR_2) As Boolean
Dim Intersection As T_VECTOR_2
    If TestRangeIntersected(From1.x, To1.x, From2.x, To2.x) And _
       TestRangeIntersected(From1.y, To1.y, From2.y, To2.y) Then
        
        On Error GoTo LabExit
        Intersection = GetLinesIntersection(From1, To1, From2, To2)
        
        TestLinesIntersected = TestVectorInBox(Intersection, From1, To1) And _
                               TestVectorInBox(Intersection, From2, To2)
LabExit:
    End If
    
End Function

Public Function TestRangeIntersected(ByVal From1 As Double, ByVal To1 As Double, ByVal From2 As Double, ByVal To2 As Double) As Boolean
    Dim tmp As Double
    If From1 > To1 Then
        tmp = From1
        From1 = To1
        To1 = tmp
    End If
    
    If From2 > To2 Then
        tmp = From2
        From2 = To2
        To2 = tmp
    End If
  
    TestRangeIntersected = ((From1 <= From2) And (From2 <= To1)) Or _
                           ((From1 <= To2) And (To2 <= To1)) Or _
                           ((From2 <= From1) And (From1 <= To2)) Or _
                           ((From2 <= To1) And (To1 <= From2))
    
End Function

Public Function TestVectorInBox(vec As T_VECTOR_2, BoxMin As T_VECTOR_2, BoxMax As T_VECTOR_2)
    TestVectorInBox = TestPointInRange(vec.x, BoxMin.x, BoxMax.x) And _
                      TestPointInRange(vec.y, BoxMin.y, BoxMax.y)
End Function

Public Function TestPointInRange(ByVal dNumber As Double, dRangeBegin As Double, dRangeEnd As Double) As Boolean
    If dRangeBegin <= dRangeEnd Then
        TestPointInRange = (dRangeBegin <= dNumber) And (dNumber <= dRangeEnd)
    Else
        TestPointInRange = (dRangeBegin >= dNumber) And (dNumber >= dRangeEnd)
    End If
End Function

Public Function GetDistance(From1 As T_VECTOR_2, To1 As T_VECTOR_2) As Double
    GetDistance = Sqr((From1.x - To1.x) ^ 2 + (From1.y - To1.y) ^ 2)
End Function

Public Function VectorAngle(vDir As T_VECTOR_2) As Double
    If vDir.x = 0 Then
        If vDir.y > 0 Then
            VectorAngle = Pi
        Else
            VectorAngle = Pi * 3
        End If
        Exit Function
    End If
    VectorAngle = -Atn(vDir.x / vDir.y)
End Function
